=== debian/changelog ===
luametatex (2.11.08+ds-1) unstable; urgency=medium

  * New upstream version, suitable for new ConTeXt.
    - Refresh patches.
  * Bump Standards version, no changes needed.

 -- Hilmar Preuße <hille42@debian.org>  Thu, 30 Oct 2025 21:56:16 +0100
