=== debian/watch ===
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig.
#opts="pgpsigurlmangle=s%$%.sig%"

# HTTP site (basic).
#http://example.com/downloads.html \
#    files/luametatex-([\d\.]+)\.tar\.gz

# Uncomment to examine an FTP server.
#ftp://ftp.example.com/pub/luametatex-(.*)\.tar\.gz

# SourceForge hosted projects.
#http://sf.net/luametatex/ luametatex-(.*)\.tar\.gz

# GitHub hosted projects.
#opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
#    https://github.com/contextgarden/luametatex/tags \
#    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
opts=repack,repacksuffix=+ds,compression=gz,dversionmangle=s/\+ds// \
    https://github.com/contextgarden/luametatex/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

# PyPI.
#https://pypi.debian.net/luametatex/luametatex-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

# Direct Git.
#opts="mode=git" http://git.example.com/luametatex.git \
#    refs/tags/v([\d\.]+)
